Index: /main/trunk/gli/src/org/greenstone/gatherer/Gatherer.java
===================================================================
--- /main/trunk/gli/src/org/greenstone/gatherer/Gatherer.java	(revision 24231)
+++ /main/trunk/gli/src/org/greenstone/gatherer/Gatherer.java	(revision 24232)
@@ -84,637 +84,641 @@
 		*/
 
-    static final public String PROGRAM_VERSION = "trunk";
-
-    static private Dimension size = new Dimension(800, 540);
-    static public RemoteGreenstoneServer remoteGreenstoneServer = null;
-
-    /** Has the exit flag been set? */
-    static final public int EXIT_THEN_RESTART= 2;
-    static public boolean exit = false;
-    static public int exit_status = 0;
-
-    static private String gli_directory_path = null;
-    static private String gli_user_directory_path = null;
-
-    static public String client_operating_system = null;
-
-    /** All of the external applications that must exit before we close the Gatherer. */
-    static private Vector apps = new Vector();
-    static private String non_standard_collect_directory_path = null;
-    static public String open_collection_file_path = null;
+	static final public String PROGRAM_VERSION = "trunk";
+
+	static private Dimension size = new Dimension(800, 540);
+	static public RemoteGreenstoneServer remoteGreenstoneServer = null;
+
+	/** Has the exit flag been set? */
+	static final public int EXIT_THEN_RESTART= 2;
+	static public boolean exit = false;
+	static public int exit_status = 0;
+
+	static private String gli_directory_path = null;
+	static private String gli_user_directory_path = null;
+
+	static public String client_operating_system = null;
+
+	/** All of the external applications that must exit before we close the Gatherer. */
+	static private Vector apps = new Vector();
+	static private String non_standard_collect_directory_path = null;
+	static public String open_collection_file_path = null;
 	static public String gsdlsite_collecthome = "";
-    /** A public reference to the FileAssociationManager. */
-    static public FileAssociationManager assoc_man;
-    /** A public reference to the CollectionManager. */
-    static public CollectionManager c_man;
-    /** A public reference to the RecycleBin. */
-    static public RecycleBin recycle_bin;
-    /** a reference to the Servlet Configuration is GS3 */
-    static public ServletConfiguration servlet_config;
-    /** A public reference to the FileManager. */
-    static public FileManager f_man;
-    /** A public reference to the GUIManager. */
-    static public GUIManager g_man = null;
-    static private boolean g_man_built = false;
-
-    /** We are using the GLI for GS3 */
-    static public boolean GS3 = false;
-
-    static public boolean isApplet = false;
-    static public boolean isGsdlRemote = false;
-    static public boolean isLocalLibrary = false;
-
-    /* TODO: If we're using local GLI, collections are built locally. If we're using client-GLI
-     * and it contains a gs2build folder in it, then localBuild will also be true (if this is not
-     * turned off in Preferences). If we're remote and this is turned off in Prefs, build remotely. */
-    /*static public boolean buildingLocally = true;*/
-    /** If we're using local GLI, we can always download. If we're using client-GLI, we can only
-     * download if we have a gs2build folder inside it. And if we don't turn off downloadEnabling
-     * in the preferences.
-    */
-    static public boolean isDownloadEnabled = true;
-
-    // feedback stuff
-    /** is the feedback feature enabled? */
-    static public boolean feedback_enabled = true;
-    /** the action recorder dialog */
-    static public ActionRecorderDialog feedback_dialog = null;
-
-    // Refresh reasons
-    static public final int COLLECTION_OPENED   = 0;
-    static public final int COLLECTION_CLOSED   = 1;
-    static public final int COLLECTION_REBUILT  = 2;
-    static public final int PREFERENCES_CHANGED = 3;
-
-   //////kk added////////  
-    static public String cgiBase="";
-    /////////////////
-
-    /** Magic to allow Enter to fire the default button. */
-    static {
-      KeyStroke enter = KeyStroke.getKeyStroke(KeyEvent.VK_ENTER, 0);
-      Keymap map = JTextComponent.getKeymap(JTextComponent.DEFAULT_KEYMAP);
-      map.removeKeyStrokeBinding(enter);
-    }
-
-    static private URL default_gliserver_url=null;
-
-    public Gatherer(String[] args) 
-    {
-	// Display the version to make error reports a lot more useful
-	System.err.println("Version: " + PROGRAM_VERSION + "\n");
-
-	JarTools.initialise(this); 
-
-	GetOpt go = new GetOpt(args);
-
-	// Remember the GSDLOS value
-	client_operating_system = go.client_operating_system;
-
-	// If feedback is enabled, set up the recorder dialog
-	if (go.feedback_enabled) {
-	    // Use the default locale for now - this will be changed by the Gatherer run method
-	    feedback_enabled = true;
-	    feedback_dialog = new ActionRecorderDialog(Locale.getDefault());
-	}
-
-	// Are we using a remote Greenstone?
-	if (go.use_remote_greenstone) {
-	    isGsdlRemote = true;
-
-	    // We don't have a local Greenstone!
-	    go.gsdl3_path=null;
-	    go.gsdl3_src_path=null;
-
-	    // Don't set go.gsdl_path to null, since gdsl_path may still be set 
-	    // if we have a client-gli containing gs2build folder. 
-	    // However, keep track of whether we can download.
-	    if(go.gsdl_path == null) {
-		isDownloadEnabled = false;
-	    }
-
-	    // We have to use our own collect directory since we can't use the Greenstone one
-	    setCollectDirectoryPath(getGLIUserDirectoryPath() + "collect" + File.separator);
-	}
-	// We have a local Greenstone. OR we have a gs2build folder inside 
-	// the client-GLI folder (with which the Download panel becomes enabled) 
-	if(isDownloadEnabled) {
-	    LocalGreenstone.setDirectoryPath(go.gsdl_path);
-	}
-
-	// Users may specify a non-standard collect directory (eg. when running one GLI in a network environment)
-	if (go.collect_directory_path != null) {
-	    setCollectDirectoryPath(go.collect_directory_path);
-	}
-
-	// More special code for running with a remote Greenstone
-	if (isGsdlRemote) {
-	    if (go.fedora_info.isActive()) {
-		Configuration.TEMPLATE_CONFIG_XML = "xml/" + Configuration.FEDORA_CONFIG_PREFIX + "configRemote.xml";
-	    }
-	    else {
-		Configuration.TEMPLATE_CONFIG_XML = "xml/configRemote.xml";
-	    }
-
-	    Configuration.CONFIG_XML = "configRemote.xml"; 
-
-	    File collect_directory = new File(Gatherer.getCollectDirectoryPath());
-	    if (!collect_directory.exists() && !collect_directory.mkdir()) {
-		System.err.println("Warning: Unable to make directory: " + collect_directory);
-	    }
-	}
-	else {	    
-	    if (go.fedora_info.isActive()) {
-		Configuration.TEMPLATE_CONFIG_XML = "xml/" + Configuration.FEDORA_CONFIG_PREFIX + Configuration.CONFIG_XML;
-	    }
-	    // else, the CONFIG_XML uses the default config file, which is for the local GS server
-	}
-
-	init(go.gsdl_path, go.gsdl3_path, go.gsdl3_src_path, 
-	     go.fedora_info,
-	     go.local_library_path, go.library_url_string, 
-	     go.gliserver_url_string, go.debug, go.perl_path, go.no_load, go.filename, go.site_name,
-	     go.servlet_path);
-    }
-
-
-    public void init(String gsdl_path, String gsdl3_path, String gsdl3_src_path, 
-		     FedoraInfo fedora_info,
-		     String local_library_path,
-		     String library_url_string, String gliserver_url_string, boolean debug_enabled,
-		     String perl_path, boolean no_load, String open_collection, 
-		     String site_name, String servlet_path) 
-    {
-	if (gsdl3_path != null && !gsdl3_path.equals("")) {
-	    this.GS3 = true;
-	} else {
-	    gsdl3_path = null;
-	    gsdl3_src_path = null;
-	}
-
-	// Create the debug stream if required
-	if (debug_enabled) {
-	    DebugStream.enableDebugging();
-
-	    Calendar now = Calendar.getInstance();
-	    String debug_file_path = "debug" + now.get(Calendar.DATE) + "-" + now.get(Calendar.MONTH) + "-" + now.get(Calendar.YEAR) + ".txt";
-
-	    // Debug file is created in the user's GLI directory
-	    debug_file_path = getGLIUserDirectoryPath() + debug_file_path;
-	    DebugStream.println("Debug file path: " + debug_file_path);
-	    DebugStream.setDebugFile(debug_file_path);
-	    DebugStream.print(System.getProperties());
-	}
-
-	// Delete plugins.dat and classifiers.dat files from previous versions of the GLI (no longer used)
-	File plugins_dat_file = new File(Gatherer.getGLIUserDirectoryPath() + "plugins.dat");
-	if (plugins_dat_file.exists()) {
-	    System.err.println("Deleting plugins.dat file...");
-	    Utility.delete(plugins_dat_file);
-	}
-	File classifiers_dat_file = new File(Gatherer.getGLIUserDirectoryPath() + "classifiers.dat");
-	if (classifiers_dat_file.exists()) {
-	    System.err.println("Deleting classifiers.dat file...");
-	    Utility.delete(classifiers_dat_file);
-	}
-
-	try {
-	    // Load GLI config file
-	    new Configuration(getGLIUserDirectoryPath(), gsdl_path, gsdl3_path, gsdl3_src_path, site_name,
-			      fedora_info);
-	    
-	    // Check we know where Perl is
-	    Configuration.perl_path = perl_path;
-	    if (isGsdlRemote && !isDownloadEnabled && Utility.isWindows() && Configuration.perl_path != null) {
-		if (Configuration.perl_path.toLowerCase().endsWith("perl.exe")) {
-		    Configuration.perl_path = Configuration.perl_path.substring(0, Configuration.perl_path.length() - "perl.exe".length());
-		}
-		if (Configuration.perl_path.endsWith(File.separator)) {
-		    Configuration.perl_path = Configuration.perl_path.substring(0, Configuration.perl_path.length() - File.separator.length());
-		}
-	    }
-
-	    // the feedback dialog has been loaded with a default locale, 
-	    // now set the user specified one
-	    if (feedback_enabled && feedback_dialog != null) {
-		feedback_dialog.setLocale(Configuration.getLocale("general.locale", true));
-	    }
-
-	    // Read Dictionary
-	    new Dictionary(Configuration.getLocale("general.locale", true), Configuration.getFont("general.font", true));
-
-	    // check that we are using Sun Java
-	    String java_vendor = System.getProperty("java.vendor");
-	    if (!java_vendor.equals("Sun Microsystems Inc.")) {
-		System.err.println(Dictionary.get("General.NotSunJava", java_vendor));
-	    }
-
-	    // Unless we're using remote building, we need to know where the local Greenstone is
-	    if (!isGsdlRemote && gsdl_path == null) {
-		missingGSDL();
-	    }
-
-	    if (fedora_info.isActive()) {
-		popupFedoraInfo();
-	    }
-		
-		// the no_load flag to GLI is processed at the end of handling open_collection_file_path
-		open_collection_file_path = open_collection;
-		if (open_collection_file_path == null) {
-			open_collection_file_path = Configuration.getString(
+	/** A public reference to the FileAssociationManager. */
+	static public FileAssociationManager assoc_man;
+	/** A public reference to the CollectionManager. */
+	static public CollectionManager c_man;
+	/** A public reference to the RecycleBin. */
+	static public RecycleBin recycle_bin;
+	/** a reference to the Servlet Configuration is GS3 */
+	static public ServletConfiguration servlet_config;
+	/** A public reference to the FileManager. */
+	static public FileManager f_man;
+	/** A public reference to the GUIManager. */
+	static public GUIManager g_man = null;
+	static private boolean g_man_built = false;
+
+	/** We are using the GLI for GS3 */
+	static public boolean GS3 = false;
+
+	static public boolean isApplet = false;
+	static public boolean isGsdlRemote = false;
+	static public boolean isLocalLibrary = false;
+
+	/* TODO: If we're using local GLI, collections are built locally. If we're using client-GLI
+	* and it contains a gs2build folder in it, then localBuild will also be true (if this is not
+	* turned off in Preferences). If we're remote and this is turned off in Prefs, build remotely. */
+	/*static public boolean buildingLocally = true;*/
+	/** If we're using local GLI, we can always download. If we're using client-GLI, we can only
+	* download if we have a gs2build folder inside it. And if we don't turn off downloadEnabling
+	* in the preferences.
+	*/
+	static public boolean isDownloadEnabled = true;
+
+	// feedback stuff
+	/** is the feedback feature enabled? */
+	static public boolean feedback_enabled = true;
+	/** the action recorder dialog */
+	static public ActionRecorderDialog feedback_dialog = null;
+
+	// Refresh reasons
+	static public final int COLLECTION_OPENED   = 0;
+	static public final int COLLECTION_CLOSED   = 1;
+	static public final int COLLECTION_REBUILT  = 2;
+	static public final int PREFERENCES_CHANGED = 3;
+
+	//////kk added////////  
+	static public String cgiBase="";
+	/////////////////
+
+	/** Magic to allow Enter to fire the default button. */
+	static {
+		KeyStroke enter = KeyStroke.getKeyStroke(KeyEvent.VK_ENTER, 0);
+		Keymap map = JTextComponent.getKeymap(JTextComponent.DEFAULT_KEYMAP);
+		map.removeKeyStrokeBinding(enter);
+	}
+
+	static private URL default_gliserver_url=null;
+
+	public Gatherer(String[] args) 
+	{
+		// Display the version to make error reports a lot more useful
+		System.err.println("Version: " + PROGRAM_VERSION + "\n");
+
+		JarTools.initialise(this); 
+
+		GetOpt go = new GetOpt(args);
+
+		// Remember the GSDLOS value
+		client_operating_system = go.client_operating_system;
+
+		// If feedback is enabled, set up the recorder dialog
+		if (go.feedback_enabled) {
+			// Use the default locale for now - this will be changed by the Gatherer run method
+			feedback_enabled = true;
+			feedback_dialog = new ActionRecorderDialog(Locale.getDefault());
+		}
+
+		// Are we using a remote Greenstone?
+		if (go.use_remote_greenstone) {
+			isGsdlRemote = true;
+
+			// We don't have a local Greenstone!
+			go.gsdl3_path=null;
+			go.gsdl3_src_path=null;
+
+			// Don't set go.gsdl_path to null, since gdsl_path may still be set 
+			// if we have a client-gli containing gs2build folder. 
+			// However, keep track of whether we can download.
+			if(go.gsdl_path == null) {
+				isDownloadEnabled = false;
+			}
+
+			// We have to use our own collect directory since we can't use the Greenstone one
+			setCollectDirectoryPath(getGLIUserDirectoryPath() + "collect" + File.separator);
+		}
+		// We have a local Greenstone. OR we have a gs2build folder inside 
+		// the client-GLI folder (with which the Download panel becomes enabled) 
+		if(isDownloadEnabled) {
+			LocalGreenstone.setDirectoryPath(go.gsdl_path);
+		}
+
+		// Users may specify a non-standard collect directory (eg. when running one GLI in a network environment)
+		if (go.collect_directory_path != null) {
+			setCollectDirectoryPath(go.collect_directory_path);
+		}
+
+		// More special code for running with a remote Greenstone
+		if (isGsdlRemote) {
+			if (go.fedora_info.isActive()) {
+				Configuration.TEMPLATE_CONFIG_XML = "xml/" + Configuration.FEDORA_CONFIG_PREFIX + "configRemote.xml";
+			}
+			else {
+				Configuration.TEMPLATE_CONFIG_XML = "xml/configRemote.xml";
+			}
+
+			Configuration.CONFIG_XML = "configRemote.xml"; 
+
+			File collect_directory = new File(Gatherer.getCollectDirectoryPath());
+			if (!collect_directory.exists() && !collect_directory.mkdir()) {
+				System.err.println("Warning: Unable to make directory: " + collect_directory);
+			}
+		}
+		else {	    
+			if (go.fedora_info.isActive()) {
+				Configuration.TEMPLATE_CONFIG_XML = "xml/" + Configuration.FEDORA_CONFIG_PREFIX + Configuration.CONFIG_XML;
+			}
+			// else, the CONFIG_XML uses the default config file, which is for the local GS server
+		}
+
+		init(go.gsdl_path, go.gsdl3_path, go.gsdl3_src_path, 
+		go.fedora_info,
+		go.local_library_path, go.library_url_string, 
+		go.gliserver_url_string, go.debug, go.perl_path, go.no_load, go.filename, go.site_name,
+		go.servlet_path);
+	}
+
+
+	public void init(String gsdl_path, String gsdl3_path, String gsdl3_src_path, 
+	FedoraInfo fedora_info,
+	String local_library_path,
+	String library_url_string, String gliserver_url_string, boolean debug_enabled,
+	String perl_path, boolean no_load, String open_collection, 
+	String site_name, String servlet_path) 
+	{
+		if (gsdl3_path != null && !gsdl3_path.equals("")) {
+			this.GS3 = true;
+		} else {
+			gsdl3_path = null;
+			gsdl3_src_path = null;
+		}
+
+		// Create the debug stream if required
+		if (debug_enabled) {
+			DebugStream.enableDebugging();
+
+			Calendar now = Calendar.getInstance();
+			String debug_file_path = "debug" + now.get(Calendar.DATE) + "-" + now.get(Calendar.MONTH) + "-" + now.get(Calendar.YEAR) + ".txt";
+
+			// Debug file is created in the user's GLI directory
+			debug_file_path = getGLIUserDirectoryPath() + debug_file_path;
+			DebugStream.println("Debug file path: " + debug_file_path);
+			DebugStream.setDebugFile(debug_file_path);
+			DebugStream.print(System.getProperties());
+		}
+
+		// Delete plugins.dat and classifiers.dat files from previous versions of the GLI (no longer used)
+		File plugins_dat_file = new File(Gatherer.getGLIUserDirectoryPath() + "plugins.dat");
+		if (plugins_dat_file.exists()) {
+			System.err.println("Deleting plugins.dat file...");
+			Utility.delete(plugins_dat_file);
+		}
+		File classifiers_dat_file = new File(Gatherer.getGLIUserDirectoryPath() + "classifiers.dat");
+		if (classifiers_dat_file.exists()) {
+			System.err.println("Deleting classifiers.dat file...");
+			Utility.delete(classifiers_dat_file);
+		}
+
+		try {
+			// Load GLI config file
+			new Configuration(getGLIUserDirectoryPath(), gsdl_path, gsdl3_path, gsdl3_src_path, site_name,
+			fedora_info);
+			
+			// Check we know where Perl is
+			Configuration.perl_path = perl_path;
+			if (isGsdlRemote && !isDownloadEnabled && Utility.isWindows() && Configuration.perl_path != null) {
+				if (Configuration.perl_path.toLowerCase().endsWith("perl.exe")) {
+					Configuration.perl_path = Configuration.perl_path.substring(0, Configuration.perl_path.length() - "perl.exe".length());
+				}
+				if (Configuration.perl_path.endsWith(File.separator)) {
+					Configuration.perl_path = Configuration.perl_path.substring(0, Configuration.perl_path.length() - File.separator.length());
+				}
+			}
+
+			// the feedback dialog has been loaded with a default locale, 
+			// now set the user specified one
+			if (feedback_enabled && feedback_dialog != null) {
+				feedback_dialog.setLocale(Configuration.getLocale("general.locale", true));
+			}
+
+			// Read Dictionary
+			new Dictionary(Configuration.getLocale("general.locale", true), Configuration.getFont("general.font", true));
+
+			// check that we are using Sun Java
+			String java_vendor = System.getProperty("java.vendor");
+			if (!java_vendor.equals("Sun Microsystems Inc.")) {
+				System.err.println(Dictionary.get("General.NotSunJava", java_vendor));
+			}
+
+			// Unless we're using remote building, we need to know where the local Greenstone is
+			if (!isGsdlRemote && gsdl_path == null) {
+				missingGSDL();
+			}
+
+			if (fedora_info.isActive()) {
+				popupFedoraInfo();
+			}
+			
+			// the no_load flag to GLI is processed at the end of handling open_collection_file_path
+			open_collection_file_path = open_collection;
+			if (open_collection_file_path == null) {
+				open_collection_file_path = Configuration.getString(
 				"general.open_collection"+Configuration.gliPropertyNameSuffix(), true);
-		}
-		
-		initCollectDirectoryPath(open_collection); 
-		
-		if (no_load || (isGsdlRemote && open_collection_file_path.equals(""))) {
-		open_collection_file_path = null;
-		}
-		
-	    // Finally, we're ready to find out the version of the remote Greenstone server 
-	    if(isGsdlRemote) {
-		// instantiate the RemoteGreenstoneServer object first
-		remoteGreenstoneServer = new RemoteGreenstoneServer();
-
-		// Set up proxy
-		setProxy();
-		// Now we set up an Authenticator
-		Authenticator.setDefault(new GAuthenticator());
-
-		int greenstoneVersion = 2;
-		requestGLIServerURL();
-		gliserver_url_string = Configuration.gliserver_url.toString();
-		
-		greenstoneVersion = remoteGreenstoneServer.getGreenstoneVersion();
-		// Display the version to make error reports a lot more useful
-		System.err.println("Remote Greenstone server version: " + greenstoneVersion);
-		if(greenstoneVersion == -1) { // remote server not running
-		    Gatherer.exit();
-		}
-		if(greenstoneVersion >= 3) {
-		    this.GS3 = true;
-		    Configuration.prepareForGS3();
-		} 
-		
-		if(fedora_info.isActive()) { 
-		    // when GS server is remote, FEDORA_HOME resides on the remote server side,
-		    // but we know the library URL from user-provided information
-		    library_url_string = fedora_info.getLibraryURL();
-		} else {
-		    library_url_string = remoteGreenstoneServer.getLibraryURL(Configuration.gliserver_url.toString());
-		}
-		// write it into the config file
-		Configuration.setString("general.library_url", true, library_url_string);
-	    }
-	    else { // local greenstone: Start up the local library server, if that's what we want
-		if (!GS3) {		
-		    isLocalLibrary = LocalLibraryServer.start(gsdl_path, local_library_path);
-		}
-		// else web library: GS server is local, but doesn't use the webserver included with GS2
-	    }
-	    
-	    // The "-library_url" option overwrites anything in the config files
-	    if (library_url_string != null && library_url_string.length() > 0) {
-		try {
-		    System.err.println("Setting library_url to " + library_url_string + "...");
-		    Configuration.library_url = new URL(library_url_string);
-		}
-		catch (MalformedURLException error) {
-		    DebugStream.printStackTrace(error);
-		}
-	    }
-  
-
-	    // Check that we now know the Greenstone library URL, since we need this for previewing collections
-	    // It is not necessary if an independent GSI was launched and the user hasn't pressed Enter Library yet
-	    DebugStream.println("Configuration.library_url = " + Configuration.library_url);
-	    if (Configuration.library_url == null) {
-		if(isLocalLibrary) {
-		    if(!LocalLibraryServer.isURLPending()) {
-			missingEXEC();
-		    }
-		    // else LocalLibraryServer is expecting a URL soon, so don't need to display the dialog
-		} else { // GS2 webLibrary or GS3 or remote Greenstone
-		    missingEXEC();
-		}
-	    }
-
-	    // The "-gliserver_url" option overwrites anything in the config files
-	    if (gliserver_url_string != null && gliserver_url_string.length() > 0) {
-		try {
-		    System.err.println("Setting gliserver_url to " + gliserver_url_string + "...");
-		    Configuration.gliserver_url = new URL(gliserver_url_string);
-		}
-		catch (MalformedURLException error) {
-		    DebugStream.printStackTrace(error);
-		}
-	    }
-
-	    // If we're using a remote Greenstone we need to know where the gliserver script is
-	    DebugStream.println("Configuration.gliserver_url = " + Configuration.gliserver_url);
-
-	    if (GS3) {
-		// Load Greenstone 3 servlet configuration
-		if (isGsdlRemote){
-		    servlet_config = new ServletConfiguration(Configuration.gli_user_directory_path);
-		}else{
-		    servlet_config= new ServletConfiguration(gsdl3_path);
-		}
-	    }
-
-	    if (GS3 && Configuration.servlet_path == null) {
-		Configuration.servlet_path = servlet_config.getServletPath(Configuration.site_name);
-	    }
-	     
-	    // ensure that a directory called 'cache' exists in the GLI user directory  
-	    File user_cache_dir = new File(Gatherer.getGLIUserCacheDirectoryPath());
-	    System.err.println("User cache dir: " + Gatherer.getGLIUserCacheDirectoryPath());
-	    if (!user_cache_dir.exists() && !user_cache_dir.mkdir()) {
-		System.err.println("Warning: Unable to make directory: " + user_cache_dir);
-	    }
-
-	    // Check for ImageMagick
-	    if (Gatherer.isGsdlRemote) {
-		DebugStream.println("Not checking for ImageMagick.");
-	    }
-	    else if (!(new ImageMagickTest()).found()) {
-		// Time for a warning message
-		missingImageMagick();
-	    }
-
-	    if (Gatherer.isGsdlRemote) {
-		DebugStream.println("Not checking for perl path/exe");
-	    }
-	    else {
-		// Perl path is a little different as it is perfectly ok to
-		// start the GLI without providing a perl path
-		boolean found_perl = false;
-		if (Configuration.perl_path != null) {
-		    // See if the file pointed to actually exists
-		    File perl_file = new File(Configuration.perl_path);
-		    found_perl = perl_file.exists();
-		    perl_file = null;
-		}
-		if (Configuration.perl_path == null || !found_perl) {
-		    // Run test to see if we can run perl as is.
-		    PerlTest perl_test = new PerlTest();
-		    if (perl_test.found()) {
-			// If so replace the perl path with the system
-			// default (or null for unix).
-			Configuration.perl_path = perl_test.toString();
-			found_perl = true;
-		    }
-		}
-		if (!found_perl) {
-		    // Time for an error message.
-		    missingPERL();
-		}
-	    }
-
-		// Check that the local can support multiple filename encodings
+			}
+			
+			initCollectDirectoryPath(open_collection); 
+			
+			if (no_load || (isGsdlRemote && open_collection_file_path.equals(""))) {
+				open_collection_file_path = null;
+			}
+			
+			// Finally, we're ready to find out the version of the remote Greenstone server 
+			if(isGsdlRemote) {
+				// instantiate the RemoteGreenstoneServer object first
+				remoteGreenstoneServer = new RemoteGreenstoneServer();
+
+				// Set up proxy
+				setProxy();
+				// Now we set up an Authenticator
+				Authenticator.setDefault(new GAuthenticator());
+
+				int greenstoneVersion = 2;
+				requestGLIServerURL();
+				gliserver_url_string = Configuration.gliserver_url.toString();
+				
+				greenstoneVersion = remoteGreenstoneServer.getGreenstoneVersion();
+				// Display the version to make error reports a lot more useful
+				System.err.println("Remote Greenstone server version: " + greenstoneVersion);
+				if(greenstoneVersion == -1) { // remote server not running
+					Gatherer.exit();
+				}
+				if(greenstoneVersion >= 3) {
+					this.GS3 = true;
+					Configuration.prepareForGS3();
+				} 
+				
+				if(fedora_info.isActive()) { 
+					// when GS server is remote, FEDORA_HOME resides on the remote server side,
+					// but we know the library URL from user-provided information
+					library_url_string = fedora_info.getLibraryURL();
+				} else {
+					library_url_string = remoteGreenstoneServer.getLibraryURL(Configuration.gliserver_url.toString());
+				}
+				// write it into the config file
+				Configuration.setString("general.library_url", true, library_url_string);
+			}
+			else { // local greenstone: Start up the local library server, if that's what we want
+				if (!GS3) {		
+					isLocalLibrary = LocalLibraryServer.start(gsdl_path, local_library_path);
+				}
+				else {
+					GS3ServerThread thread = new GS3ServerThread(gsdl_path);
+					thread.start();
+				}
+				// else web library: GS server is local, but doesn't use the webserver included with GS2
+			}
+			
+			// The "-library_url" option overwrites anything in the config files
+			if (library_url_string != null && library_url_string.length() > 0) {
+				try {
+					System.err.println("Setting library_url to " + library_url_string + "...");
+					Configuration.library_url = new URL(library_url_string);
+				}
+				catch (MalformedURLException error) {
+					DebugStream.printStackTrace(error);
+				}
+			}
+
+
+			// Check that we now know the Greenstone library URL, since we need this for previewing collections
+			// It is not necessary if an independent GSI was launched and the user hasn't pressed Enter Library yet
+			DebugStream.println("Configuration.library_url = " + Configuration.library_url);
+			if (Configuration.library_url == null) {
+				if(isLocalLibrary) {
+					if(!LocalLibraryServer.isURLPending()) {
+						missingEXEC();
+					}
+					// else LocalLibraryServer is expecting a URL soon, so don't need to display the dialog
+				} else { // GS2 webLibrary or GS3 or remote Greenstone
+					missingEXEC();
+				}
+			}
+
+			// The "-gliserver_url" option overwrites anything in the config files
+			if (gliserver_url_string != null && gliserver_url_string.length() > 0) {
+				try {
+					System.err.println("Setting gliserver_url to " + gliserver_url_string + "...");
+					Configuration.gliserver_url = new URL(gliserver_url_string);
+				}
+				catch (MalformedURLException error) {
+					DebugStream.printStackTrace(error);
+				}
+			}
+
+			// If we're using a remote Greenstone we need to know where the gliserver script is
+			DebugStream.println("Configuration.gliserver_url = " + Configuration.gliserver_url);
+
+			if (GS3) {
+				// Load Greenstone 3 servlet configuration
+				if (isGsdlRemote){
+					servlet_config = new ServletConfiguration(Configuration.gli_user_directory_path);
+				}else{
+					servlet_config= new ServletConfiguration(gsdl3_path);
+				}
+			}
+
+			if (GS3 && Configuration.servlet_path == null) {
+				Configuration.servlet_path = servlet_config.getServletPath(Configuration.site_name);
+			}
+			
+			// ensure that a directory called 'cache' exists in the GLI user directory  
+			File user_cache_dir = new File(Gatherer.getGLIUserCacheDirectoryPath());
+			System.err.println("User cache dir: " + Gatherer.getGLIUserCacheDirectoryPath());
+			if (!user_cache_dir.exists() && !user_cache_dir.mkdir()) {
+				System.err.println("Warning: Unable to make directory: " + user_cache_dir);
+			}
+
+			// Check for ImageMagick
+			if (Gatherer.isGsdlRemote) {
+				DebugStream.println("Not checking for ImageMagick.");
+			}
+			else if (!(new ImageMagickTest()).found()) {
+				// Time for a warning message
+				missingImageMagick();
+			}
+
+			if (Gatherer.isGsdlRemote) {
+				DebugStream.println("Not checking for perl path/exe");
+			}
+			else {
+				// Perl path is a little different as it is perfectly ok to
+				// start the GLI without providing a perl path
+				boolean found_perl = false;
+				if (Configuration.perl_path != null) {
+					// See if the file pointed to actually exists
+					File perl_file = new File(Configuration.perl_path);
+					found_perl = perl_file.exists();
+					perl_file = null;
+				}
+				if (Configuration.perl_path == null || !found_perl) {
+					// Run test to see if we can run perl as is.
+					PerlTest perl_test = new PerlTest();
+					if (perl_test.found()) {
+						// If so replace the perl path with the system
+						// default (or null for unix).
+						Configuration.perl_path = perl_test.toString();
+						found_perl = true;
+					}
+				}
+				if (!found_perl) {
+					// Time for an error message.
+					missingPERL();
+				}
+			}
+
+			// Check that the local can support multiple filename encodings
 			//System.err.println("#### Java identifies current Locale as (file.encoding): "
 			//	+ System.getProperty("file.encoding"));
-	    if(System.getProperty("file.encoding").equals("UTF-8")){
-			// If the locale is UTF-8, Java will interpret all filename bytes as UTF-8, 
-			// which is a destructive process as it will convert characters not recognised
-			// by UTF-8 into the invalid character, rather than preserving the bytecodes.
-			// This has the effect that non-UTF8 encoded filenames on a system set to a 
-			// UTF-8 locale are not 'seen' by Java (if they contain non-ASCII characters).
-			multipleFilenameEncodingsNotSupported();		
-			FilenameEncoding.MULTIPLE_FILENAME_ENCODINGS_SUPPORTED = false; 
-			FilenameEncoding.URL_FILE_SEPARATOR = File.separator;
-	    } else {
-			FilenameEncoding.MULTIPLE_FILENAME_ENCODINGS_SUPPORTED = true;
-			FilenameEncoding.URL_FILE_SEPARATOR = "/"; // URL file separator is always "/" 
-	    }
-		
-	    // Set the default font for all Swing components.
-	    FontUIResource default_font = Configuration.getFont("general.font", true);
-	    Enumeration keys = UIManager.getDefaults().keys();
-	    while (keys.hasMoreElements()) {
-		Object key = keys.nextElement();
-		Object value = UIManager.get(key);
-		if (value instanceof FontUIResource) {
-		    UIManager.put(key, default_font);
-		}
-	    }
-
-	    // At this point (which is where this code originally used to be), we can set up the proxy for the
-	    // non-remote case. The remote Greenstone server would already have setup its proxy when required.
-	    if(!isGsdlRemote) {
-		setProxy();
-		// Now we set up an Authenticator
-		Authenticator.setDefault(new GAuthenticator());
-	    }
-	    assoc_man = new FileAssociationManager();
-	    // Create File Manager
-	    f_man = new FileManager();
-	    // Create Collection Manager
-	    c_man = new CollectionManager();
-	    // Create Recycle Bin
-	    recycle_bin = new RecycleBin();
-
-	    if (GS3) {
-		if (site_name==null) {
-		    site_name = Configuration.site_name;
-		    servlet_path = null; // need to reset this
-		}
-		if (servlet_path == null) {
-		    servlet_path = Configuration.getServletPath();
-		}
-	    }
-	    
-		
-	} catch (Exception exception) {
-	    DebugStream.printStackTrace(exception);
+			if(System.getProperty("file.encoding").equals("UTF-8")){
+				// If the locale is UTF-8, Java will interpret all filename bytes as UTF-8, 
+				// which is a destructive process as it will convert characters not recognised
+				// by UTF-8 into the invalid character, rather than preserving the bytecodes.
+				// This has the effect that non-UTF8 encoded filenames on a system set to a 
+				// UTF-8 locale are not 'seen' by Java (if they contain non-ASCII characters).
+				multipleFilenameEncodingsNotSupported();		
+				FilenameEncoding.MULTIPLE_FILENAME_ENCODINGS_SUPPORTED = false; 
+				FilenameEncoding.URL_FILE_SEPARATOR = File.separator;
+			} else {
+				FilenameEncoding.MULTIPLE_FILENAME_ENCODINGS_SUPPORTED = true;
+				FilenameEncoding.URL_FILE_SEPARATOR = "/"; // URL file separator is always "/" 
+			}
+			
+			// Set the default font for all Swing components.
+			FontUIResource default_font = Configuration.getFont("general.font", true);
+			Enumeration keys = UIManager.getDefaults().keys();
+			while (keys.hasMoreElements()) {
+				Object key = keys.nextElement();
+				Object value = UIManager.get(key);
+				if (value instanceof FontUIResource) {
+					UIManager.put(key, default_font);
+				}
+			}
+
+			// At this point (which is where this code originally used to be), we can set up the proxy for the
+			// non-remote case. The remote Greenstone server would already have setup its proxy when required.
+			if(!isGsdlRemote) {
+				setProxy();
+				// Now we set up an Authenticator
+				Authenticator.setDefault(new GAuthenticator());
+			}
+			assoc_man = new FileAssociationManager();
+			// Create File Manager
+			f_man = new FileManager();
+			// Create Collection Manager
+			c_man = new CollectionManager();
+			// Create Recycle Bin
+			recycle_bin = new RecycleBin();
+
+			if (GS3) {
+				if (site_name==null) {
+					site_name = Configuration.site_name;
+					servlet_path = null; // need to reset this
+				}
+				if (servlet_path == null) {
+					servlet_path = Configuration.getServletPath();
+				}
+			}
+			
+			
+		} catch (Exception exception) {
+			DebugStream.printStackTrace(exception);
+		}
+
+		
+		// Create GUI Manager (last) or else suffer the death of a thousand NPE's
+		g_man = new GUIManager(size);
+
+		// Get a list of the core Greenstone classifiers and plugins
+		Classifiers.loadClassifiersList(null);
+		Plugins.loadPluginsList(null);
+
+		// If using a remote Greenstone we need to download the collection configurations now
+		if (Gatherer.isGsdlRemote) {
+			if (remoteGreenstoneServer.downloadCollectionConfigurations().equals("")) {
+				// !! Something went wrong downloading the collection configurations
+				System.err.println("Error: Could not download collection configurations.");
+				if(!Gatherer.isApplet) { // don't close the browser if it is an applet!
+					System.exit(0);
+				}
+			}
+		}
 	}
 
 	
-	// Create GUI Manager (last) or else suffer the death of a thousand NPE's
-	g_man = new GUIManager(size);
-
-	// Get a list of the core Greenstone classifiers and plugins
-	Classifiers.loadClassifiersList(null);
+	/** Returns the correct version of the (local or remote) Greenstone server if init() has already been called. */
+	public static int serverVersionNumber() { 
+		return GS3 ? 3 : 2;
+	} 
+
+	/** Returns "Server: version number" if init() has already been called. */
+	public static String getServerVersionAsString() { 
+		return "Server: v" + serverVersionNumber();
+	} 
+
+	public void openGUI()
+	{
+		// Size and place the frame on the screen
+		Rectangle bounds = Configuration.getBounds("general.bounds", true);
+		if (bounds == null) {
+			// Choose a sensible default value
+			bounds = new Rectangle(0, 0, 640, 480);
+		}
+		
+		// Ensure width and height are reasonable
+		size = bounds.getSize();
+		if (size.width < 640) {
+			size.width = 640;
+		}
+		else if (size.width > Configuration.screen_size.width && Configuration.screen_size.width > 0) {
+			size.width = Configuration.screen_size.width;
+		}
+		if (size.height < 480) {
+			size.height = 480;
+		}
+		else if (size.height > Configuration.screen_size.height && Configuration.screen_size.height > 0) {
+			size.height = Configuration.screen_size.height;
+		}
+
+		if (!g_man_built) {
+
+			g_man.display();
+
+			// Place the window in the desired location on the screen, if this is do-able (not under most linux window managers apparently. In fact you're lucky if they listen to any of your screen size requests).
+			g_man.setLocation(bounds.x, bounds.y);
+			g_man.setVisible(true);
+
+			// After the window has been made visible, check that it is in the correct place
+			// sometimes java places a window not in the correct place, 
+			// but with an offset. If so, we work out what the offset is
+			// and change the desired location to take that into account 
+			Point location = g_man.getLocation();
+			int x_offset = bounds.x - location.x;
+			int y_offset = bounds.y - location.y;
+			// If not, offset the window to move it into the correct location
+			if (x_offset > 0 || y_offset > 0) {
+				///ystem.err.println("changing the location to "+(bounds.x + x_offset)+" "+ (bounds.y + y_offset));
+				g_man.setLocation(bounds.x + x_offset, bounds.y + y_offset);
+			}
+
+			// The 'after-display' triggers several events which don't occur until after the visual components are actually available on screen. Examples of these would be the various html renderings, as they can't happen offscreen.
+			g_man.afterDisplay();
+			g_man_built = true;
+		}
+		else {
+			g_man.setVisible(true);
+		}
+
+		// Get a list of the core Greenstone classifiers and plugins
+		/*Classifiers.loadClassifiersList(null);
 	Plugins.loadPluginsList(null);
 
 	// If using a remote Greenstone we need to download the collection configurations now
 	if (Gatherer.isGsdlRemote) {
-	    if (remoteGreenstoneServer.downloadCollectionConfigurations().equals("")) {
-		// !! Something went wrong downloading the collection configurations
-		System.err.println("Error: Could not download collection configurations.");
-		if(!Gatherer.isApplet) { // don't close the browser if it is an applet!
-		    System.exit(0);
-		}
-	    }
-	}
-    }
-
-    
-    /** Returns the correct version of the (local or remote) Greenstone server if init() has already been called. */
-    public static int serverVersionNumber() { 
-	return GS3 ? 3 : 2;
-    } 
-
-    /** Returns "Server: version number" if init() has already been called. */
-    public static String getServerVersionAsString() { 
-	return "Server: v" + serverVersionNumber();
-    } 
-
-    public void openGUI()
-    {
-	// Size and place the frame on the screen
-	Rectangle bounds = Configuration.getBounds("general.bounds", true);
-	if (bounds == null) {
-	    // Choose a sensible default value
-	    bounds = new Rectangle(0, 0, 640, 480);
-	}
-	
-	// Ensure width and height are reasonable
-	size = bounds.getSize();
-	if (size.width < 640) {
-	    size.width = 640;
-	}
-	else if (size.width > Configuration.screen_size.width && Configuration.screen_size.width > 0) {
-	    size.width = Configuration.screen_size.width;
-	}
-	if (size.height < 480) {
-	    size.height = 480;
-	}
-	else if (size.height > Configuration.screen_size.height && Configuration.screen_size.height > 0) {
-	    size.height = Configuration.screen_size.height;
-	}
-
-	if (!g_man_built) {
-
-	    g_man.display();
-
-	    // Place the window in the desired location on the screen, if this is do-able (not under most linux window managers apparently. In fact you're lucky if they listen to any of your screen size requests).
-	    g_man.setLocation(bounds.x, bounds.y);
-	    g_man.setVisible(true);
-
-	    // After the window has been made visible, check that it is in the correct place
-	    // sometimes java places a window not in the correct place, 
-	    // but with an offset. If so, we work out what the offset is
-	    // and change the desired location to take that into account 
-	    Point location = g_man.getLocation();
-	    int x_offset = bounds.x - location.x;
-	    int y_offset = bounds.y - location.y;
-	    // If not, offset the window to move it into the correct location
-	    if (x_offset > 0 || y_offset > 0) {
-		///ystem.err.println("changing the location to "+(bounds.x + x_offset)+" "+ (bounds.y + y_offset));
-		g_man.setLocation(bounds.x + x_offset, bounds.y + y_offset);
-	    }
-
-	    // The 'after-display' triggers several events which don't occur until after the visual components are actually available on screen. Examples of these would be the various html renderings, as they can't happen offscreen.
-	    g_man.afterDisplay();
-	    g_man_built = true;
-	}
-	else {
-	    g_man.setVisible(true);
-	}
-
-	// Get a list of the core Greenstone classifiers and plugins
-	/*Classifiers.loadClassifiersList(null);
-	Plugins.loadPluginsList(null);
-
-	// If using a remote Greenstone we need to download the collection configurations now
-	if (Gatherer.isGsdlRemote) {
-	    if (remoteGreenstoneServer.downloadCollectionConfigurations().equals("")) {
+		if (remoteGreenstoneServer.downloadCollectionConfigurations().equals("")) {
 		// !! Something went wrong downloading the collection configurations
 		System.err.println("Error: Could not download collection configurations.");
 		System.exit(0);
-	    }
+		}
 	}*/
 
-	// If there was a collection left open last time, reopen it	
-	 if (open_collection_file_path == null || new File(Gatherer.open_collection_file_path).isDirectory()) {
-      
-      //the menu bar items, file and edit, are disabled from the moment of their creation. if there is no left-over collection from the last session, enable them; otherwise it is untill the collection finishes loading, will they be enabled in collectionManager.java
-	  setMenuBarEnabled(true);
-      } else {
-  
-      // If there was a collection left open last time, reopen it
-	  c_man.openCollectionFromLastTime();
-      }
-    }
-
-    public static void setMenuBarEnabled(boolean enabled) {
-      g_man.menu_bar.file.setEnabled(enabled);
-      g_man.menu_bar.edit.setEnabled(enabled);
-    }
-
-    /** Exits the Gatherer after ensuring that things needing saving are saved.
-     * @see java.io.FileOutputStream
-     * @see java.io.PrintStream
-     * @see java.lang.Exception
-     * @see javax.swing.JOptionPane
-     * @see org.greenstone.gatherer.Configuration
-     * @see org.greenstone.gatherer.collection.CollectionManager
-     * @see org.greenstone.gatherer.gui.GUIManager
-     */
-    static public void exit(int new_exit_status)
-    {
-	DebugStream.println("In Gatherer.exit()...");
-	exit = true;
-	if (new_exit_status != 0) {
-	    // default exit_status is already 0 
-	    // only remember a new exit status if it is non-trivial
-	    exit_status = new_exit_status;
-	}
-
-	// Save the file associations
-	if (assoc_man != null) {
-	    assoc_man.save();
-	    assoc_man = null;
-	}
-
-	// Get the gui to deallocate
-	if(g_man != null) {
-	    g_man.destroy();
-	    g_man_built = false;
-	}
-
-	// Flush debug
-	DebugStream.closeDebugStream();
-	
-	// If we started a server, we should try to stop it.
-	if (LocalLibraryServer.isRunning() == true) {		
-	    LocalLibraryServer.stop();
-	}
-
-	// If we're using a remote Greenstone server we need to make sure that all jobs have completed first
-	if (isGsdlRemote) {
-	    remoteGreenstoneServer.exit();
-	}
-
-	// Make sure we haven't started up any processes that are still running
-	if (apps.size() == 0) {
-	    // If we're running as an applet we don't actually quit (just hide the main GLI window)
-	    if (!Gatherer.isApplet) {
-		// This is the end...
-		System.exit(exit_status);
-	    }
-	}
-	else {
-	    JOptionPane.showMessageDialog(g_man, Dictionary.get("General.Outstanding_Processes"), Dictionary.get("General.Outstanding_Processes_Title"), JOptionPane.ERROR_MESSAGE);
-	    g_man.setVisible(false);
-	}
-    }
-
-    static public void exit()
-    {
-	exit(0);
-    }
-
-    /** Returns the path of the current collect directory. */
-    static public String getCollectDirectoryPath()
-    {
-	if (non_standard_collect_directory_path != null) {
-	    return non_standard_collect_directory_path;
-	}
-	
-	return getDefaultGSCollectDirectoryPath(true); // file separator appended
-	
-    }
+		// If there was a collection left open last time, reopen it	
+		if (open_collection_file_path == null || new File(Gatherer.open_collection_file_path).isDirectory()) {
+			
+			//the menu bar items, file and edit, are disabled from the moment of their creation. if there is no left-over collection from the last session, enable them; otherwise it is untill the collection finishes loading, will they be enabled in collectionManager.java
+			setMenuBarEnabled(true);
+		} else {
+
+			// If there was a collection left open last time, reopen it
+			c_man.openCollectionFromLastTime();
+		}
+	}
+
+	public static void setMenuBarEnabled(boolean enabled) {
+		g_man.menu_bar.file.setEnabled(enabled);
+		g_man.menu_bar.edit.setEnabled(enabled);
+	}
+
+	/** Exits the Gatherer after ensuring that things needing saving are saved.
+	* @see java.io.FileOutputStream
+	* @see java.io.PrintStream
+	* @see java.lang.Exception
+	* @see javax.swing.JOptionPane
+	* @see org.greenstone.gatherer.Configuration
+	* @see org.greenstone.gatherer.collection.CollectionManager
+	* @see org.greenstone.gatherer.gui.GUIManager
+	*/
+	static public void exit(int new_exit_status)
+	{
+		DebugStream.println("In Gatherer.exit()...");
+		exit = true;
+		if (new_exit_status != 0) {
+			// default exit_status is already 0 
+			// only remember a new exit status if it is non-trivial
+			exit_status = new_exit_status;
+		}
+
+		// Save the file associations
+		if (assoc_man != null) {
+			assoc_man.save();
+			assoc_man = null;
+		}
+
+		// Get the gui to deallocate
+		if(g_man != null) {
+			g_man.destroy();
+			g_man_built = false;
+		}
+
+		// Flush debug
+		DebugStream.closeDebugStream();
+		
+		// If we started a server, we should try to stop it.
+		if (LocalLibraryServer.isRunning() == true) {		
+			LocalLibraryServer.stop();
+		}
+
+		// If we're using a remote Greenstone server we need to make sure that all jobs have completed first
+		if (isGsdlRemote) {
+			remoteGreenstoneServer.exit();
+		}
+
+		// Make sure we haven't started up any processes that are still running
+		if (apps.size() == 0) {
+			// If we're running as an applet we don't actually quit (just hide the main GLI window)
+			if (!Gatherer.isApplet) {
+				// This is the end...
+				System.exit(exit_status);
+			}
+		}
+		else {
+			JOptionPane.showMessageDialog(g_man, Dictionary.get("General.Outstanding_Processes"), Dictionary.get("General.Outstanding_Processes_Title"), JOptionPane.ERROR_MESSAGE);
+			g_man.setVisible(false);
+		}
+	}
+
+	static public void exit()
+	{
+		exit(0);
+	}
+
+	/** Returns the path of the current collect directory. */
+	static public String getCollectDirectoryPath()
+	{
+		if (non_standard_collect_directory_path != null) {
+			return non_standard_collect_directory_path;
+		}
+		
+		return getDefaultGSCollectDirectoryPath(true); // file separator appended
+		
+	}
 	
 	// if we need to know whether the local server we are running is server.exe vs apache web server
